// 
// File:          sidl_MemAllocException.hxx
// Symbol:        sidl.MemAllocException-v0.9.17
// Symbol Type:   class
// Babel Version: 1.4.0
// Release:       $Name:  $
// Revision:      @(#) $Id: $
// Description:   Client-side glue code for sidl.MemAllocException
// 
// Copyright (c) 2000-2002, Lawrence Livermore National Security, LLC.
// Produced at the Lawrence Livermore National Laboratory.
// Written by the Components Team <components@llnl.gov>
// All rights reserved.
// 
// This file is part of Babel. For more information, see
// http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
// for Our Notice and the LICENSE file for the GNU Lesser General Public
// License.
// 
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License (as published by
// the Free Software Foundation) version 2.1 dated February 1999.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
// conditions of the GNU Lesser General Public License for more details.
// 
// You should have recieved a copy of the GNU Lesser General Public License
// along with this program; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_sidl_MemAllocException_hxx
#define included_sidl_MemAllocException_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace sidl { 

  class MemAllocException;
} // end namespace sidl

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::sidl::MemAllocException >;
}
// 
// Forward declarations for method dependencies.
// 
namespace sidl { 

  class MemAllocException;
} // end namespace sidl

namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_sidl_MemAllocException_IOR_h
#include "sidl_MemAllocException_IOR.h"
#endif
#ifndef included_sidl_RuntimeException_hxx
#include "sidl_RuntimeException.hxx"
#endif
#ifndef included_sidl_SIDLException_hxx
#include "sidl_SIDLException.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace sidl { 

  /**
   * Symbol "sidl.MemAllocException" (version 0.9.17)
   * 
   * Exception thrown from Babel internals when memory allocation
   * fails.  This exception is special in that it avoids any memory
   * allocation.  For this reason, the trace or note may be truncated
   * to fit in the preallocated buffers.
   */
  class MemAllocException: public virtual ::sidl::RuntimeException, public 
    virtual ::sidl::SIDLException {

    //////////////////////////////////////////////////
    // 
    // Special methods for throwing exceptions
    // 

  private:
    static 
    void
    throwException0(
      const char* methodName,
      struct sidl_BaseInterface__object *_exception
    )
      // throws:
    ;

    //////////////////////////////////////////////////
    // 
    // User Defined Methods
    // 

  public:

    /**
     * Returns the preallocated copy of this exception.  Any
     * failure of memory allocation should throw the exception returned
     * by this method to avoid further allocation failures.
     */
    static ::sidl::MemAllocException
    getSingletonException() ;


    /**
     * Return the message associated with the exception.
     */
    ::std::string
    getNote() ;


    /**
     * Set the message associated with the exception.
     */
    void
    setNote (
      /* in */const ::std::string& message
    )
    ;



    /**
     * Returns formatted string containing the concatenation of all 
     * tracelines.
     */
    ::std::string
    getTrace() ;


    /**
     * Adds a stringified entry/line to the stack trace.
     */
    void
    add (
      /* in */const ::std::string& traceline
    )
    ;



    /**
     * Formats and adds an entry to the stack trace based on the 
     * file name, line number, and method name.
     */
    void
    add (
      /* in */const ::std::string& filename,
      /* in */int32_t lineno,
      /* in */const ::std::string& methodname
    )
    ;



    //////////////////////////////////////////////////
    // 
    // End User Defined Methods
    // (everything else in this file is specific to
    //  Babel's C++ bindings)
    // 

  public:
    typedef struct sidl_MemAllocException__object ior_t;
    typedef struct sidl_MemAllocException__external ext_t;
    typedef struct sidl_MemAllocException__sepv sepv_t;

    // default constructor
    MemAllocException() { }
    // static constructor
    static ::sidl::MemAllocException _create();


#ifdef WITH_RMI

    // RMI constructor
    static ::sidl::MemAllocException _create( /*in*/ const std::string& url );

    // RMI connect
    static inline ::sidl::MemAllocException _connect( /*in*/ const std::string& 
      url ) { 
      return _connect(url, true);
    }

    // RMI connect 2
    static ::sidl::MemAllocException _connect( /*in*/ const std::string& url, 
      /*in*/ const bool ar  );


#endif /*WITH_RMI*/

    // default destructor
    virtual ~MemAllocException () { }

    // copy constructor
    MemAllocException ( const MemAllocException& original );

    // assignment operator
    MemAllocException& operator= ( const MemAllocException& rhs );

    // conversion from ior to C++ class
    MemAllocException ( MemAllocException::ior_t* ior );

    // Alternate constructor: does not call addRef()
    // (sets d_weak_reference=isWeak)
    // For internal use by Impls (fixes bug#275)
    MemAllocException ( MemAllocException::ior_t* ior, bool isWeak );

    inline ior_t* _get_ior() const throw() {
      return reinterpret_cast< ior_t*>(d_self);
    }

    inline void _set_ior( ior_t* ptr ) throw () { 
      d_self = reinterpret_cast< void*>(ptr);

      if( ptr != NULL ) {
        sidl_RuntimeException_IORCache = &((*ptr).d_sidl_runtimeexception);
        sidl_io_Serializable_IORCache = &((
          *ptr).d_sidl_sidlexception.d_sidl_io_serializable);
        sidl_BaseException_IORCache = &((
          *ptr).d_sidl_sidlexception.d_sidl_baseexception);
      } else {
        sidl_RuntimeException_IORCache = NULL;
        sidl_io_Serializable_IORCache = NULL;
        sidl_BaseException_IORCache = NULL;
      }
    }

    virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                   const ::std::type_info &argtype );

    bool _is_nil() const throw () { return (d_self==0); }

    bool _not_nil() const throw () { return (d_self!=0); }

    bool operator !() const throw () { return (d_self==0); }

    static inline const char * type_name() throw () { return 
      "sidl.MemAllocException";}

    static struct sidl_MemAllocException__object* _cast(const void* src);

    // execute member function by name
    void _exec(const std::string& methodName,
               ::sidl::rmi::Call& inArgs,
               ::sidl::rmi::Return& outArgs);
    // exec static member function by name
    static void _sexec(const std::string& methodName,
                       ::sidl::rmi::Call& inArgs,
                       ::sidl::rmi::Return& outArgs);


    /**
     * Get the URL of the Implementation of this object (for RMI)
     */
    ::std::string
    _getURL() // throws:
    //    ::sidl::RuntimeException
    ;


    /**
     * Method to enable/disable method hooks invocation.
     */
    void
    _set_hooks (
      /* in */bool enable
    )
    // throws:
    //    ::sidl::RuntimeException
    ;


    /**
     * Static Method to enable/disable method hooks invocation.
     */
    static void
    _set_hooks_static (
      /* in */bool enable
    )
    // throws:
    //    ::sidl::RuntimeException
    ;

    // return true iff object is remote
    bool _isRemote() const { 
      ior_t* self = const_cast<ior_t*>(_get_ior() );
      struct sidl_BaseInterface__object *throwaway_exception;
      return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
    }

    // return true iff object is local
    bool _isLocal() const {
      return !_isRemote();
    }

  protected:
    // Pointer to external (DLL loadable) symbols (shared among instances)
    static const ext_t * s_ext;

  public:
    static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

    static const sepv_t * _get_sepv() {
      return (*(_get_ext()->getStaticEPV))();
    }

  }; // end class MemAllocException
} // end namespace sidl

extern "C" {


#pragma weak sidl_MemAllocException__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct sidl_MemAllocException__object*
  sidl_MemAllocException__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::sidl::MemAllocException > {
    typedef array< ::sidl::MemAllocException > cxx_array_t;
    typedef ::sidl::MemAllocException cxx_item_t;
    typedef struct sidl_MemAllocException__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct sidl_MemAllocException__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::sidl::MemAllocException > > iterator;
    typedef const_array_iter< array_traits< ::sidl::MemAllocException > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::sidl::MemAllocException >: public interface_array< 
    array_traits< ::sidl::MemAllocException > > {
  public:
    typedef interface_array< array_traits< ::sidl::MemAllocException > > Base;
    typedef array_traits< ::sidl::MemAllocException >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::sidl::MemAllocException >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::sidl::MemAllocException >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::sidl::MemAllocException >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::sidl::MemAllocException >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct sidl_MemAllocException__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::sidl::MemAllocException >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::sidl::MemAllocException >&
    operator =( const array< ::sidl::MemAllocException >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
