// 
// File:          sidlx_rmi_Settings.hxx
// Symbol:        sidlx.rmi.Settings-v0.1
// Symbol Type:   class
// Babel Version: 1.4.0
// Description:   Client-side glue code for sidlx.rmi.Settings
// 
// WARNING: Automatically generated; changes will be lost
// 
// 

#ifndef included_sidlx_rmi_Settings_hxx
#define included_sidlx_rmi_Settings_hxx

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
// declare class before main #includes
// (this alleviates circular #include guard problems)[BUG#393]
namespace sidlx { 
  namespace rmi { 

    class Settings;
  } // end namespace rmi
} // end namespace sidlx

// Some compilers need to define array template before the specializations
namespace sidl {
  template<>
  class array< ::sidlx::rmi::Settings >;
}
// 
// Forward declarations for method dependencies.
// 
namespace sidl { 

  class RuntimeException;
} // end namespace sidl

#ifndef included_sidl_cxx_hxx
#include "sidl_cxx.hxx"
#endif
#ifndef included_sidlx_rmi_Settings_IOR_h
#include "sidlx_rmi_Settings_IOR.h"
#endif
#ifndef included_sidl_BaseClass_hxx
#include "sidl_BaseClass.hxx"
#endif
namespace sidl {
  namespace rmi {
    class Call;
    class Return;
    class Ticket;
  }
  namespace rmi {
    class InstanceHandle;
  }
}
namespace sidlx { 
  namespace rmi { 

    /**
     * Symbol "sidlx.rmi.Settings" (version 0.1)
     * 
     * Low level settings
     */
    class Settings: public virtual ::sidl::BaseClass {

      //////////////////////////////////////////////////
      // 
      // Special methods for throwing exceptions
      // 

    private:
      static 
      void
      throwException0(
        const char* methodName,
        struct sidl_BaseInterface__object *_exception
      )
        // throws:
      ;

      //////////////////////////////////////////////////
      // 
      // User Defined Methods
      // 

    public:

      /**
       *  default = getenv(SIDLX_ACCEPT_MAX_RETRIES) else 0 
       */
      static int32_t
      getMaxAcceptRetries() ;


      /**
       *  override default 
       */
      static void
      setMaxAcceptRetries (
        /* in */int32_t retries
      )
      ;



      /**
       *  default = getenv(SIDLX_ACCEPT_RETRY_INITIAL_SLEEP_USECS) else 1024 
       */
      static int64_t
      getAcceptRetryInitialSleep() ;


      /**
       *  overrride default 
       */
      static void
      setAcceptRetryInitialSleep (
        /* in */int64_t usecs
      )
      ;



      /**
       *  default = getenv(SIDLX_CONNECT_MAX_RETRIES) else 0 
       */
      static int32_t
      getMaxConnectRetries() ;


      /**
       *  override default 
       */
      static void
      setMaxConnectRetries (
        /* in */int32_t retries
      )
      ;



      /**
       *  default = getenv(SIDLX_CONNECT_RETRY_INITIAL_SLEEP_USECS) else 1024 
       */
      static int64_t
      getConnectRetryInitialSleep() ;


      /**
       *  overrride default 
       */
      static void
      setConnectRetryInitialSleep (
        /* in */int64_t usecs
      )
      ;



      //////////////////////////////////////////////////
      // 
      // End User Defined Methods
      // (everything else in this file is specific to
      //  Babel's C++ bindings)
      // 

    public:
      typedef struct sidlx_rmi_Settings__object ior_t;
      typedef struct sidlx_rmi_Settings__external ext_t;
      typedef struct sidlx_rmi_Settings__sepv sepv_t;

      // default constructor
      Settings() { }
      // static constructor
      static ::sidlx::rmi::Settings _create();


#ifdef WITH_RMI

      // RMI constructor
      static ::sidlx::rmi::Settings _create( /*in*/ const std::string& url );

      // RMI connect
      static inline ::sidlx::rmi::Settings _connect( /*in*/ const std::string& 
        url ) { 
        return _connect(url, true);
      }

      // RMI connect 2
      static ::sidlx::rmi::Settings _connect( /*in*/ const std::string& url, 
        /*in*/ const bool ar  );


#endif /*WITH_RMI*/

      // default destructor
      virtual ~Settings () { }

      // copy constructor
      Settings ( const Settings& original );

      // assignment operator
      Settings& operator= ( const Settings& rhs );


      protected:
      // Internal data wrapping method
      static ior_t*  _wrapObj(void* private_data);


      public:
      // conversion from ior to C++ class
      Settings ( Settings::ior_t* ior );

      // Alternate constructor: does not call addRef()
      // (sets d_weak_reference=isWeak)
      // For internal use by Impls (fixes bug#275)
      Settings ( Settings::ior_t* ior, bool isWeak );

      inline ior_t* _get_ior() const throw() {
        return reinterpret_cast< ior_t*>(d_self);
      }

      inline void _set_ior( ior_t* ptr ) throw () { 
        d_self = reinterpret_cast< void*>(ptr);

        if( ptr != NULL ) {
        } else {
        }
      }

      virtual int _set_ior_typesafe( struct sidl_BaseInterface__object *obj,
                                     const ::std::type_info &argtype );

      bool _is_nil() const throw () { return (d_self==0); }

      bool _not_nil() const throw () { return (d_self!=0); }

      bool operator !() const throw () { return (d_self==0); }

      static inline const char * type_name() throw () { return 
        "sidlx.rmi.Settings";}

      static struct sidlx_rmi_Settings__object* _cast(const void* src);

      // execute member function by name
      void _exec(const std::string& methodName,
                 ::sidl::rmi::Call& inArgs,
                 ::sidl::rmi::Return& outArgs);
      // exec static member function by name
      static void _sexec(const std::string& methodName,
                         ::sidl::rmi::Call& inArgs,
                         ::sidl::rmi::Return& outArgs);


      /**
       * Get the URL of the Implementation of this object (for RMI)
       */
      ::std::string
      _getURL() // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Method to enable/disable method hooks invocation.
       */
      void
      _set_hooks (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;


      /**
       * Static Method to enable/disable method hooks invocation.
       */
      static void
      _set_hooks_static (
        /* in */bool enable
      )
      // throws:
      //    ::sidl::RuntimeException
      ;

      // return true iff object is remote
      bool _isRemote() const { 
        ior_t* self = const_cast<ior_t*>(_get_ior() );
        struct sidl_BaseInterface__object *throwaway_exception;
        return (*self->d_epv->f__isRemote)(self, &throwaway_exception) == TRUE;
      }

      // return true iff object is local
      bool _isLocal() const {
        return !_isRemote();
      }

    protected:
      // Pointer to external (DLL loadable) symbols (shared among instances)
      static const ext_t * s_ext;

    public:
      static const ext_t * _get_ext() throw ( ::sidl::NullIORException );

      static const sepv_t * _get_sepv() {
        return (*(_get_ext()->getStaticEPV))();
      }

    }; // end class Settings
  } // end namespace rmi
} // end namespace sidlx

extern "C" {


#pragma weak sidlx_rmi_Settings__connectI

  /**
   * RMI connector function for the class. (no addref)
   */
  struct sidlx_rmi_Settings__object*
  sidlx_rmi_Settings__connectI(const char * url, sidl_bool ar, struct 
    sidl_BaseInterface__object **_ex);


} // end extern "C"
namespace sidl {
  // traits specialization
  template<>
  struct array_traits< ::sidlx::rmi::Settings > {
    typedef array< ::sidlx::rmi::Settings > cxx_array_t;
    typedef ::sidlx::rmi::Settings cxx_item_t;
    typedef struct sidlx_rmi_Settings__array ior_array_t;
    typedef sidl_interface__array ior_array_internal_t;
    typedef struct sidlx_rmi_Settings__object ior_item_t;
    typedef cxx_item_t value_type;
    typedef value_type reference;
    typedef value_type* pointer;
    typedef const value_type const_reference;
    typedef const value_type* const_pointer;
    typedef array_iter< array_traits< ::sidlx::rmi::Settings > > iterator;
    typedef const_array_iter< array_traits< ::sidlx::rmi::Settings > > 
      const_iterator;
  };

  // array specialization
  template<>
  class array< ::sidlx::rmi::Settings >: public interface_array< array_traits< 
    ::sidlx::rmi::Settings > > {
  public:
    typedef interface_array< array_traits< ::sidlx::rmi::Settings > > Base;
    typedef array_traits< ::sidlx::rmi::Settings >::cxx_array_t          
      cxx_array_t;
    typedef array_traits< ::sidlx::rmi::Settings >::cxx_item_t           
      cxx_item_t;
    typedef array_traits< ::sidlx::rmi::Settings >::ior_array_t          
      ior_array_t;
    typedef array_traits< ::sidlx::rmi::Settings >::ior_array_internal_t 
      ior_array_internal_t;
    typedef array_traits< ::sidlx::rmi::Settings >::ior_item_t           
      ior_item_t;

    /**
     * conversion from ior to C++ class
     * (constructor/casting operator)
     */
    array( struct sidlx_rmi_Settings__array* src = 0) : Base(src) {}

    /**
     * copy constructor
     */
    array( const array< ::sidlx::rmi::Settings >&src) : Base(src) {}

    /**
     * assignment
     */
    array< ::sidlx::rmi::Settings >&
    operator =( const array< ::sidlx::rmi::Settings >&rhs ) { 
      if (d_array != rhs._get_baseior()) {
        if (d_array) deleteRef();
        d_array = const_cast<sidl__array *>(rhs._get_baseior());
        if (d_array) addRef();
      }
      return *this;
    }

  };
}

#endif
