/*
 * File:          sidl_EnfPolicy_fStub.c
 * Symbol:        sidl.EnfPolicy-v0.9.17
 * Symbol Type:   class
 * Babel Version: 1.4.0
 * Release:       $Name:  $
 * Revision:      @(#) $Id: $
 * Description:   Client-side glue code for sidl.EnfPolicy
 * 
 * Copyright (c) 2000-2002, Lawrence Livermore National Security, LLC.
 * Produced at the Lawrence Livermore National Laboratory.
 * Written by the Components Team <components@llnl.gov>
 * All rights reserved.
 * 
 * This file is part of Babel. For more information, see
 * http://www.llnl.gov/CASC/components/. Please read the COPYRIGHT file
 * for Our Notice and the LICENSE file for the GNU Lesser General Public
 * License.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License (as published by
 * the Free Software Foundation) version 2.1 dated February 1999.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
 * conditions of the GNU Lesser General Public License for more details.
 * 
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * WARNING: Automatically generated; changes will be lost
 * 
 */

/*
 * Symbol "sidl.EnfPolicy" (version 0.9.17)
 * 
 * <code>EnfPolicy</code> maintains the current interface
 * contract enforcement policy.
 */

#ifndef included_sidl_EnfPolicy_fStub_h
#include "sidl_EnfPolicy_fStub.h"
#endif
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "sidlfortran.h"
#ifndef included_sidl_io_Serializer_h
#include "sidl_io_Serializer.h"
#endif
#ifndef included_sidl_io_Deserializer_h
#include "sidl_io_Deserializer.h"
#endif
#include <stdio.h>
#ifndef included_sidlf90array_h
#include "sidlf90array.h"
#endif
#include "sidl_header.h"
#ifndef included_sidl_interface_IOR_h
#include "sidl_interface_IOR.h"
#endif
#ifndef included_sidl_Exception_h
#include "sidl_Exception.h"
#endif
#include "sidl_EnfPolicy_IOR.h"
#include "sidl_EnfPolicy_fAbbrev.h"
#include "sidl_BaseException_IOR.h"
#include "sidl_BaseInterface_IOR.h"
#include "sidl_ClassInfo_IOR.h"
#include "sidl_ContractClass_IOR.h"
#include "sidl_EnfTraceLevel_IOR.h"
#include "sidl_EnforceFreq_IOR.h"
#include "sidl_RuntimeException_IOR.h"
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidlOps_h
#include "sidlOps.h"
#endif
/*
 * Includes for all method dependencies.
 */

#ifndef included_sidl_BaseClass_fStub_h
#include "sidl_BaseClass_fStub.h"
#endif
#ifndef included_sidl_BaseInterface_fStub_h
#include "sidl_BaseInterface_fStub.h"
#endif
#ifndef included_sidl_ClassInfo_fStub_h
#include "sidl_ClassInfo_fStub.h"
#endif
#ifndef included_sidl_EnfPolicy_fStub_h
#include "sidl_EnfPolicy_fStub.h"
#endif
#ifndef included_sidl_RuntimeException_fStub_h
#include "sidl_RuntimeException_fStub.h"
#endif

#define LANG_SPECIFIC_INIT()
#ifdef WITH_RMI
static struct sidl_EnfPolicy__object* sidl_EnfPolicy__remoteCreate(const char* 
  url, sidl_BaseInterface *_ex);
static struct sidl_EnfPolicy__object* sidl_EnfPolicy__remoteConnect(const char* 
  url, sidl_bool ar, sidl_BaseInterface *_ex);
static struct sidl_EnfPolicy__object* sidl_EnfPolicy__IHConnect(struct 
  sidl_rmi_InstanceHandle__object *instance, struct sidl_BaseInterface__object 
  **_ex);
#endif /*WITH_RMI*/
/*
 * Return pointer to internal IOR functions.
 */

static const struct sidl_EnfPolicy__external* _getIOR(void)
{
  static const struct sidl_EnfPolicy__external *_ior = NULL;
  if (!_ior) {
    _ior = sidl_EnfPolicy__externals();
  }
  return _ior;
}

/*
 * Return pointer to static functions.
 */

static const struct sidl_EnfPolicy__sepv* _getSEPV(void)
{
  static const struct sidl_EnfPolicy__sepv *_sepv = NULL;
  if (!_sepv) {
    _sepv = (*(_getIOR()->getStaticEPV))();
  }
  return _sepv;
}

/*
 * Constructor for the class.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_newlocal_m,SIDL_ENFPOLICY_NEWLOCAL_M,sidl_EnfPolicy_newLocal_m)
(
  int64_t *self,
  int64_t *exception
)
{
  struct sidl_BaseInterface__object *_ior_exception = NULL;
  *self = (ptrdiff_t) (*(_getIOR()->createObject))(NULL,&_ior_exception);
  *exception = (ptrdiff_t)_ior_exception;
  if (_ior_exception) *self = 0;
}



/*
 * Remote Constructor for the class.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_newremote_m,SIDL_ENFPOLICY_NEWREMOTE_M,sidl_EnfPolicy_newRemote_m)
(
  int64_t *self,
  SIDL_F90_String url
  SIDL_F90_STR_NEAR_LEN_DECL(url),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(url)
)
{
#ifdef WITH_RMI
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  char* _proxy_url = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_url =
    sidl_copy_fortran_str(SIDL_F90_STR(url),(ptrdiff_t)
      SIDL_F90_STR_LEN(url));
  _proxy_self = sidl_EnfPolicy__remoteCreate(_proxy_url, &_proxy_exception);
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *self = (ptrdiff_t)_proxy_self;
  }
  free((void *)_proxy_url);
#endif /*WITH_RMI*/
}

/*
 * Remote Connector for the class.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_rconnect_m,SIDL_ENFPOLICY_RCONNECT_M,sidl_EnfPolicy_rConnect_m)
(
  int64_t *self,
  SIDL_F90_String url
  SIDL_F90_STR_NEAR_LEN_DECL(url),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(url)
)
{
#ifdef WITH_RMI
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  char* _proxy_url = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_url =
    sidl_copy_fortran_str(SIDL_F90_STR(url),(ptrdiff_t)
      SIDL_F90_STR_LEN(url));
  _proxy_self = sidl_EnfPolicy__remoteConnect(_proxy_url, 1, &_proxy_exception);
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *self = (ptrdiff_t)_proxy_self;
  }
  free((void *)_proxy_url);
#endif /*WITH_RMI*/
}
/*
 * Cast method for interface and type conversions.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy__cast_m,SIDL_ENFPOLICY__CAST_M,sidl_EnfPolicy__cast_m)
(
  int64_t *ref,
  int64_t *retval,
  int64_t *exception
)
{
#ifdef WITH_RMI
  static int connect_loaded = 0;
#endif /*WITH_RMI*/
  struct sidl_BaseInterface__object  *_base =
    (struct sidl_BaseInterface__object *)(ptrdiff_t)*ref;
  struct sidl_BaseInterface__object *proxy_exception;

  *retval = 0;

#ifdef WITH_RMI

  if(!connect_loaded) {
    sidl_rmi_ConnectRegistry_registerConnect("sidl.EnfPolicy", (
      void*)sidl_EnfPolicy__IHConnect, &proxy_exception);
    SIDL_CHECK(proxy_exception);
    connect_loaded = 1;
  }

#endif /*WITH_RMI*/

  if (_base) {
    *retval = (ptrdiff_t)(
      *_base->d_epv->f__cast)(
      _base->d_object,
      "sidl.EnfPolicy", &proxy_exception);
  } else {
    *retval = 0;
    proxy_exception = 0;
  }
#ifdef WITH_RMI
  EXIT:
#endif /*WITH_RMI*/
  *exception = (ptrdiff_t)proxy_exception;
}

/*
 * Cast method for interface and class type conversions.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy__cast2_m,SIDL_ENFPOLICY__CAST2_M,sidl_EnfPolicy__cast2_m)
(
  int64_t *self,
  SIDL_F90_String name
  SIDL_F90_STR_NEAR_LEN_DECL(name),
  int64_t *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(name)
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  char* _proxy_name = NULL;
  void* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _proxy_name =
    sidl_copy_fortran_str(SIDL_F90_STR(name),(ptrdiff_t)
      SIDL_F90_STR_LEN(name));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__cast))(
      _proxy_self,
      _proxy_name,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
  free((void *)_proxy_name);
}


/*
 * Select and execute a method by name
 */

void
SIDLFortran90Symbol(sidl_enfpolicy__exec_m,SIDL_ENFPOLICY__EXEC_M,sidl_EnfPolicy__exec_m)
(
  int64_t *self,
  SIDL_F90_String methodName
  SIDL_F90_STR_NEAR_LEN_DECL(methodName),
  int64_t *inArgs,
  int64_t *outArgs,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(methodName)
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  char* _proxy_methodName = NULL;
  struct sidl_rmi_Call__object* _proxy_inArgs = NULL;
  struct sidl_rmi_Return__object* _proxy_outArgs = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _proxy_methodName =
    sidl_copy_fortran_str(SIDL_F90_STR(methodName),(ptrdiff_t)
      SIDL_F90_STR_LEN(methodName));
  _proxy_inArgs =
    (struct sidl_rmi_Call__object*)
    (ptrdiff_t)(*inArgs);
  _proxy_outArgs =
    (struct sidl_rmi_Return__object*)
    (ptrdiff_t)(*outArgs);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__exec))(
    _proxy_self,
    _proxy_methodName,
    _proxy_inArgs,
    _proxy_outArgs,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_methodName);
}


/*
 * Get the URL of the Implementation of this object (for RMI)
 */

void
SIDLFortran90Symbol(sidl_enfpolicy__geturl_m,SIDL_ENFPOLICY__GETURL_M,sidl_EnfPolicy__getURL_m)
(
  int64_t *self,
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__getURL))(
      _proxy_self,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
}


/*
 * TRUE if this object is remote, false if local
 */

void
SIDLFortran90Symbol(sidl_enfpolicy__isremote_m,SIDL_ENFPOLICY__ISREMOTE_M,sidl_EnfPolicy__isRemote_m)
(
  int64_t *self,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f__isRemote))(
      _proxy_self,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}


/*
 * TRUE if this object is remote, false if local
 */

void
SIDLFortran90Symbol(sidl_enfpolicy__islocal_m,SIDL_ENFPOLICY__ISLOCAL_M,sidl_EnfPolicy__isLocal_m)
(
  int64_t *self,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    !(*(_epv->f__isRemote))(
      _proxy_self,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}


/*
 * Method to enable/disable method hooks invocation.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy__set_hooks_m,SIDL_ENFPOLICY__SET_HOOKS_M,sidl_EnfPolicy__set_hooks_m)
(
  int64_t *self,
  SIDL_F90_Bool *enable,
  int64_t *exception
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  sidl_bool _proxy_enable;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _proxy_enable = ((*enable == SIDL_F90_TRUE) ? TRUE : FALSE);
  _epv = _proxy_self->d_epv;
  (*(_epv->f__set_hooks))(
    _proxy_self,
    _proxy_enable,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}


/*
 * Static Method to enable/disable method hooks invocation.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy__set_hooks_static_m,SIDL_ENFPOLICY__SET_HOOKS_STATIC_M,sidl_EnfPolicy__set_hooks_static_m)
(
  SIDL_F90_Bool *enable,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  sidl_bool _proxy_enable;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_enable = ((*enable == SIDL_F90_TRUE) ? TRUE : FALSE);
  (*(_epv->f__set_hooks_static))(
    _proxy_enable,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * <p>
 * Add one to the intrinsic reference count in the underlying object.
 * Object in <code>sidl</code> have an intrinsic reference count.
 * Objects continue to exist as long as the reference count is
 * positive. Clients should call this method whenever they
 * create another ongoing reference to an object or interface.
 * </p>
 * <p>
 * This does not have a return value because there is no language
 * independent type that can refer to an interface or a
 * class.
 * </p>
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_addref_m,SIDL_ENFPOLICY_ADDREF_M,sidl_EnfPolicy_addRef_m)
(
  int64_t *self,
  int64_t *exception
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_addRef))(
    _proxy_self,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Decrease by one the intrinsic reference count in the underlying
 * object, and delete the object if the reference is non-positive.
 * Objects in <code>sidl</code> have an intrinsic reference count.
 * Clients should call this method whenever they remove a
 * reference to an object or interface.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_deleteref_m,SIDL_ENFPOLICY_DELETEREF_M,sidl_EnfPolicy_deleteRef_m)
(
  int64_t *self,
  int64_t *exception
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  (*(_epv->f_deleteRef))(
    _proxy_self,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Return true if and only if <code>obj</code> refers to the same
 * object as this object.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_issame_m,SIDL_ENFPOLICY_ISSAME_M,sidl_EnfPolicy_isSame_m)
(
  int64_t *self,
  int64_t *iobj,
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  struct sidl_BaseInterface__object* _proxy_iobj = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _proxy_iobj =
    (struct sidl_BaseInterface__object*)
    (ptrdiff_t)(*iobj);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_isSame))(
      _proxy_self,
      _proxy_iobj,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}

/*
 * Return whether this object is an instance of the specified type.
 * The string name must be the <code>sidl</code> type name.  This
 * routine will return <code>true</code> if and only if a cast to
 * the string type name would succeed.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_istype_m,SIDL_ENFPOLICY_ISTYPE_M,sidl_EnfPolicy_isType_m)
(
  int64_t *self,
  SIDL_F90_String name
  SIDL_F90_STR_NEAR_LEN_DECL(name),
  SIDL_F90_Bool *retval,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(name)
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  char* _proxy_name = NULL;
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _proxy_name =
    sidl_copy_fortran_str(SIDL_F90_STR(name),(ptrdiff_t)
      SIDL_F90_STR_LEN(name));
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_isType))(
      _proxy_self,
      _proxy_name,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
  free((void *)_proxy_name);
}

/*
 * Return the meta-data about the class implementing this interface.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_getclassinfo_m,SIDL_ENFPOLICY_GETCLASSINFO_M,sidl_EnfPolicy_getClassInfo_m)
(
  int64_t *self,
  int64_t *retval,
  int64_t *exception
)
{
  struct sidl_EnfPolicy__epv *_epv = NULL;
  struct sidl_EnfPolicy__object* _proxy_self = NULL;
  struct sidl_ClassInfo__object* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_self =
    (struct sidl_EnfPolicy__object*)
    (ptrdiff_t)(*self);
  _epv = _proxy_self->d_epv;
  _proxy_retval = 
    (*(_epv->f_getClassInfo))(
      _proxy_self,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = (ptrdiff_t)_proxy_retval;
  }
}

/*
 * Sets the enforcement policy to always check the specified
 * type(s) of contracts.  This is equivalent to calling
 * setPolicy() with ALWAYS as the enforcement frequency
 * and the specified (or default) contract class.
 * 
 * @param contractClass  Contract classification
 * [Default = ALLCLASSES]
 * @param clearStats      TRUE if enforcement statistics are to be
 * cleared; FALSE otherwise.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_setenforceall_m,SIDL_ENFPOLICY_SETENFORCEALL_M,sidl_EnfPolicy_setEnforceAll_m)
(
  int64_t *contractClass,
  SIDL_F90_Bool *clearStats,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  sidl_bool _proxy_clearStats;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_clearStats = ((*clearStats == SIDL_F90_TRUE) ? TRUE : FALSE);
  (*(_epv->f_setEnforceAll))(
    *contractClass,
    _proxy_clearStats,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Sets the policy options to disable all contract enforcement.
 * This is equivalent to calling setPolicy() with NEVER as the
 * enforcement frequency.
 * 
 * @param clearStats  TRUE if enforcement statistics are to be
 * cleared; FALSE otherwise.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_setenforcenone_m,SIDL_ENFPOLICY_SETENFORCENONE_M,sidl_EnfPolicy_setEnforceNone_m)
(
  SIDL_F90_Bool *clearStats,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  sidl_bool _proxy_clearStats;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_clearStats = ((*clearStats == SIDL_F90_TRUE) ? TRUE : FALSE);
  (*(_epv->f_setEnforceNone))(
    _proxy_clearStats,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Sets enforcement policy and options.  This method should be
 * invoked directly to avoid the default enforcement behavior.
 * 
 * @param contractClass  Contract classification
 * [Default = ALLCLASSES]
 * @param enforceFreq    Enforcement frequency
 * [Default = ALWAYS]
 * @param interval       Sampling interval representing the
 * period (for PERIODIC) or maximum
 * random number/window (for RANDOM)
 * [Default = 0 if negative specified]
 * @param overheadLimit  Limit on performance overhead [0.0 .. 1.0)
 * [Default = 0.0 (or 0%) if negative]
 * @param appAvgPerCall  Average extra, application-specific
 * execution time, normalized by calls
 * to annotated methods
 * [Default = 0.0 if negative]
 * @param annealLimit    Limit on simulated annealing function
 * to ensure its termination
 * (0.0 .. 2.72]
 * [Default = 2.72 if negative specified]
 * @param clearStats      TRUE if enforcement statistics are to be
 * cleared; FALSE otherwise.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_setpolicy_m,SIDL_ENFPOLICY_SETPOLICY_M,sidl_EnfPolicy_setPolicy_m)
(
  int64_t *contractClass,
  int64_t *enforceFreq,
  int32_t *interval,
  double *overheadLimit,
  double *appAvgPerCall,
  double *annealLimit,
  SIDL_F90_Bool *clearStats,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  sidl_bool _proxy_clearStats;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_clearStats = ((*clearStats == SIDL_F90_TRUE) ? TRUE : FALSE);
  (*(_epv->f_setPolicy))(
    *contractClass,
    *enforceFreq,
    *interval,
    *overheadLimit,
    *appAvgPerCall,
    *annealLimit,
    _proxy_clearStats,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Returns TRUE if contract enforcement is enabled; FALSE otherwise.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_areenforcing_m,SIDL_ENFPOLICY_AREENFORCING_M,sidl_EnfPolicy_areEnforcing_m)
(
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_retval = 
    (*(_epv->f_areEnforcing))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}

/*
 * Returns the contract classification policy option.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_getcontractclass_m,SIDL_ENFPOLICY_GETCONTRACTCLASS_M,sidl_EnfPolicy_getContractClass_m)
(
  int64_t *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  *retval = 
    (*(_epv->f_getContractClass))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Returns the enforcement frequency policy option.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_getenforcefreq_m,SIDL_ENFPOLICY_GETENFORCEFREQ_M,sidl_EnfPolicy_getEnforceFreq_m)
(
  int64_t *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  *retval = 
    (*(_epv->f_getEnforceFreq))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Returns the interval for PERIODIC (i.e., the interval) or
 * RANDOM (i.e., the maximum random number).  Returns 0 by default.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_getsamplinginterval_m,SIDL_ENFPOLICY_GETSAMPLINGINTERVAL_M,sidl_EnfPolicy_getSamplingInterval_m)
(
  int32_t *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  *retval = 
    (*(_epv->f_getSamplingInterval))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Returns the desired enforcement overhead limit for
 * performance-driven frequency options (i.e., ADAPTFIT,
 * ADAPTTIMING, and SIMANNEAL).  Returns 0.0 by default.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_getoverheadlimit_m,SIDL_ENFPOLICY_GETOVERHEADLIMIT_M,sidl_EnfPolicy_getOverheadLimit_m)
(
  double *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  *retval = 
    (*(_epv->f_getOverheadLimit))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Returns the average assumed execution time associated
 * with the program or application.  Returns 0.0 by default.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_getappavgpercall_m,SIDL_ENFPOLICY_GETAPPAVGPERCALL_M,sidl_EnfPolicy_getAppAvgPerCall_m)
(
  double *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  *retval = 
    (*(_epv->f_getAppAvgPerCall))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Returns the annealing limit for SIMANNEAL enforcement
 * frequency option.  Returns 0.0 by default.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_getanneallimit_m,SIDL_ENFPOLICY_GETANNEALLIMIT_M,sidl_EnfPolicy_getAnnealLimit_m)
(
  double *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  *retval = 
    (*(_epv->f_getAnnealLimit))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Returns the name, or description, of the enforcement policy.
 * The caller is responsible for calling sidl_String_free()
 * on the name when done with it.
 * 
 * @param useAbbrev   TRUE if the abbreviated name is to be
 * returned.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_getpolicyname_m,SIDL_ENFPOLICY_GETPOLICYNAME_M,sidl_EnfPolicy_getPolicyName_m)
(
  SIDL_F90_Bool *useAbbrev,
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  sidl_bool _proxy_useAbbrev;
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_useAbbrev = ((*useAbbrev == SIDL_F90_TRUE) ? TRUE : FALSE);
  _proxy_retval = 
    (*(_epv->f_getPolicyName))(
      _proxy_useAbbrev,
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
}

/*
 * Prints statistics data to the file with the specified name.
 * The file is opened (for append) and closed on each call.
 * 
 * @param filename   Name of the file to which the statistics
 * data should be written.
 * @param header     TRUE if the header line is to be printed
 * prior to the statistics line (for compressed
 * output only).
 * @param prefix     String description for identifying information,
 * if any, intended to preceed the statistics
 * data.  Useful for distinguishing between
 * different objects, for example.
 * @param compressed TRUE if the enforcer state is to be dumped
 * on a single line with semi-colon separators
 * between fields.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_dumpstats_m,SIDL_ENFPOLICY_DUMPSTATS_M,sidl_EnfPolicy_dumpStats_m)
(
  SIDL_F90_String filename
  SIDL_F90_STR_NEAR_LEN_DECL(filename),
  SIDL_F90_Bool *header,
  SIDL_F90_String prefix
  SIDL_F90_STR_NEAR_LEN_DECL(prefix),
  SIDL_F90_Bool *compressed,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(filename)
  SIDL_F90_STR_FAR_LEN_DECL(prefix)
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  char* _proxy_filename = NULL;
  sidl_bool _proxy_header;
  char* _proxy_prefix = NULL;
  sidl_bool _proxy_compressed;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_filename =
    sidl_copy_fortran_str(SIDL_F90_STR(filename),(ptrdiff_t)
      SIDL_F90_STR_LEN(filename));
  _proxy_header = ((*header == SIDL_F90_TRUE) ? TRUE : FALSE);
  _proxy_prefix =
    sidl_copy_fortran_str(SIDL_F90_STR(prefix),(ptrdiff_t)
      SIDL_F90_STR_LEN(prefix));
  _proxy_compressed = ((*compressed == SIDL_F90_TRUE) ? TRUE : FALSE);
  (*(_epv->f_dumpStats))(
    _proxy_filename,
    _proxy_header,
    _proxy_prefix,
    _proxy_compressed,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_filename);
  free((void *)_proxy_prefix);
}

/*
 * Starts enforcement trace file generation.
 * 
 * @param filename    Name of the destination trace file.
 * @param traceLevel  Level of trace timing and reporting required.
 * [Default = NONE]
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_starttrace_m,SIDL_ENFPOLICY_STARTTRACE_M,sidl_EnfPolicy_startTrace_m)
(
  SIDL_F90_String filename
  SIDL_F90_STR_NEAR_LEN_DECL(filename),
  int64_t *traceLevel,
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(filename)
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  char* _proxy_filename = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_filename =
    sidl_copy_fortran_str(SIDL_F90_STR(filename),(ptrdiff_t)
      SIDL_F90_STR_LEN(filename));
  (*(_epv->f_startTrace))(
    _proxy_filename,
    *traceLevel,
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
  free((void *)_proxy_filename);
}

/*
 * Returns TRUE if contract enforcement tracing is enabled;
 * FALSE otherwise.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_aretracing_m,SIDL_ENFPOLICY_ARETRACING_M,sidl_EnfPolicy_areTracing_m)
(
  SIDL_F90_Bool *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  sidl_bool _proxy_retval;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_retval = 
    (*(_epv->f_areTracing))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    *retval = ((_proxy_retval == TRUE) ? SIDL_F90_TRUE : SIDL_F90_FALSE);
  }
}

/*
 * Returns the name of the trace file.  If one was not provided,
 * the default name is returned.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_gettracefilename_m,SIDL_ENFPOLICY_GETTRACEFILENAME_M,sidl_EnfPolicy_getTraceFilename_m)
(
  SIDL_F90_String retval
  SIDL_F90_STR_NEAR_LEN_DECL(retval),
  int64_t *exception
  SIDL_F90_STR_FAR_LEN_DECL(retval)
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  char* _proxy_retval = NULL;
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  _proxy_retval = 
    (*(_epv->f_getTraceFilename))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
    sidl_copy_c_str(
      SIDL_F90_STR(retval),(size_t)
      SIDL_F90_STR_LEN(retval),
      _proxy_retval);
    if (_proxy_retval) free(_proxy_retval);
  }
}

/*
 * Returns the level of enforcement tracing.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_gettracelevel_m,SIDL_ENFPOLICY_GETTRACELEVEL_M,sidl_EnfPolicy_getTraceLevel_m)
(
  int64_t *retval,
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  *retval = 
    (*(_epv->f_getTraceLevel))(
      &_proxy_exception
    );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

/*
 * Terminates enforcement trace file generation.  Takes a final
 * timestamp and logs the remaining trace information.
 */

void
SIDLFortran90Symbol(sidl_enfpolicy_endtrace_m,SIDL_ENFPOLICY_ENDTRACE_M,sidl_EnfPolicy_endTrace_m)
(
  int64_t *exception
)
{
  const struct sidl_EnfPolicy__sepv *_epv = _getSEPV();
  struct sidl_BaseInterface__object* _proxy_exception = NULL;
  (*(_epv->f_endTrace))(
    &_proxy_exception
  );
  if (_proxy_exception) {
    *exception = (ptrdiff_t)_proxy_exception;
  }
  else {
    *exception = (ptrdiff_t)NULL;
  }
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_createcol_m,
                  SIDL_ENFPOLICY__ARRAY_CREATECOL_M,
                  sidl_EnfPolicy__array_createCol_m)
  (int32_t *dimen,
   int32_t lower[],
   int32_t upper[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_createCol(*dimen, lower, upper);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_createrow_m,
                  SIDL_ENFPOLICY__ARRAY_CREATEROW_M,
                  sidl_EnfPolicy__array_createRow_m)
  (int32_t *dimen,
   int32_t lower[],
   int32_t upper[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_createRow(*dimen, lower, upper);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_create1d_m,
                  SIDL_ENFPOLICY__ARRAY_CREATE1D_M,
                  sidl_EnfPolicy__array_create1d_m)
  (int32_t *len, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create1d(*len);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_create2dcol_m,
                  SIDL_ENFPOLICY__ARRAY_CREATE2DCOL_M,
                  sidl_EnfPolicy__array_create2dCol_m)
  (int32_t *m, int32_t *n, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create2dCol(*m, *n);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_create2drow_m,
                  SIDL_ENFPOLICY__ARRAY_CREATE2DROW_M,
                  sidl_EnfPolicy__array_create2dRow_m)
  (int32_t *m, int32_t *n, int64_t *result)
{
  *result = (ptrdiff_t)sidl_interface__array_create2dRow(*m, *n);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_addref_m,
                  SIDL_ENFPOLICY__ARRAY_ADDREF_M,
                  sidl_EnfPolicy__array_addRef_m)
  (int64_t *array)
{
  sidl_interface__array_addRef((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_deleteref_m,
                  SIDL_ENFPOLICY__ARRAY_DELETEREF_M,
                  sidl_EnfPolicy__array_deleteRef_m)
  (int64_t *array)
{
  sidl_interface__array_deleteRef((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_get1_m,
                  SIDL_ENFPOLICY__ARRAY_GET1_M,
                  sidl_EnfPolicy__array_get1_m)
  (int64_t *array, 
   int32_t *i1, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get1((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_get2_m,
                  SIDL_ENFPOLICY__ARRAY_GET2_M,
                  sidl_EnfPolicy__array_get2_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get2((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_get3_m,
                  SIDL_ENFPOLICY__ARRAY_GET3_M,
                  sidl_EnfPolicy__array_get3_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get3((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_get4_m,
                  SIDL_ENFPOLICY__ARRAY_GET4_M,
                  sidl_EnfPolicy__array_get4_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get4((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_get5_m,
                  SIDL_ENFPOLICY__ARRAY_GET5_M,
                  sidl_EnfPolicy__array_get5_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get5((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_get6_m,
                  SIDL_ENFPOLICY__ARRAY_GET6_M,
                  sidl_EnfPolicy__array_get6_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int32_t *i6, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get6((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5, *i6);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_get7_m,
                  SIDL_ENFPOLICY__ARRAY_GET7_M,
                  sidl_EnfPolicy__array_get7_m)
  (int64_t *array, 
   int32_t *i1, 
   int32_t *i2, 
   int32_t *i3, 
   int32_t *i4, 
   int32_t *i5, 
   int32_t *i6, 
   int32_t *i7, 
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get7((const struct sidl_interface__array *)(
      ptrdiff_t)*array
    , *i1, *i2, *i3, *i4, *i5, *i6, *i7);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_get_m,
                  SIDL_ENFPOLICY__ARRAY_GET_M,
                  sidl_EnfPolicy__array_get_m)
  (int64_t *array,
   int32_t indices[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_get((const struct sidl_interface__array *)(
      ptrdiff_t)*array, indices);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_set1_m,
                  SIDL_ENFPOLICY__ARRAY_SET1_M,
                  sidl_EnfPolicy__array_set1_m)
  (int64_t *array,
   int32_t *i1,
   int64_t *value)
{
  sidl_interface__array_set1((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_set2_m,
                  SIDL_ENFPOLICY__ARRAY_SET2_M,
                  sidl_EnfPolicy__array_set2_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int64_t *value)
{
  sidl_interface__array_set2((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_set3_m,
                  SIDL_ENFPOLICY__ARRAY_SET3_M,
                  sidl_EnfPolicy__array_set3_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int64_t *value)
{
  sidl_interface__array_set3((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_set4_m,
                  SIDL_ENFPOLICY__ARRAY_SET4_M,
                  sidl_EnfPolicy__array_set4_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int64_t *value)
{
  sidl_interface__array_set4((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_set5_m,
                  SIDL_ENFPOLICY__ARRAY_SET5_M,
                  sidl_EnfPolicy__array_set5_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int64_t *value)
{
  sidl_interface__array_set5((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_set6_m,
                  SIDL_ENFPOLICY__ARRAY_SET6_M,
                  sidl_EnfPolicy__array_set6_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int32_t *i6,
   int64_t *value)
{
  sidl_interface__array_set6((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, *i6, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_set7_m,
                  SIDL_ENFPOLICY__ARRAY_SET7_M,
                  sidl_EnfPolicy__array_set7_m)
  (int64_t *array,
   int32_t *i1,
   int32_t *i2,
   int32_t *i3,
   int32_t *i4,
   int32_t *i5,
   int32_t *i6,
   int32_t *i7,
   int64_t *value)
{
  sidl_interface__array_set7((struct sidl_interface__array *)(ptrdiff_t)*array
  , *i1, *i2, *i3, *i4, *i5, *i6, *i7, (struct sidl_BaseInterface__object *)(
    ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_set_m,
                  SIDL_ENFPOLICY__ARRAY_SET_M,
                  sidl_EnfPolicy__array_set_m)
  (int64_t *array,
  int32_t indices[],
  int64_t *value)
{
  sidl_interface__array_set((struct sidl_interface__array *)(ptrdiff_t)*array, 
    indices, (struct sidl_BaseInterface__object *)(ptrdiff_t)*value);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_dimen_m,
                  SIDL_ENFPOLICY__ARRAY_DIMEN_M,
                  sidl_EnfPolicy__array_dimen_m)
  (int64_t *array, int32_t *result)
{
  *result =
    sidl_interface__array_dimen((struct sidl_interface__array *)(
      ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_lower_m,
                  SIDL_ENFPOLICY__ARRAY_LOWER_M,
                  sidl_EnfPolicy__array_lower_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_lower((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_upper_m,
                  SIDL_ENFPOLICY__ARRAY_UPPER_M,
                  sidl_EnfPolicy__array_upper_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_upper((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_length_m,
                  SIDL_ENFPOLICY__ARRAY_LENGTH_M,
                  sidl_EnfPolicy__array_length_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_length((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_stride_m,
                  SIDL_ENFPOLICY__ARRAY_STRIDE_M,
                  sidl_EnfPolicy__array_stride_m)
  (int64_t *array,
   int32_t *ind,
   int32_t *result)
{
  *result = 
    sidl_interface__array_stride((struct sidl_interface__array *)(
      ptrdiff_t)*array, *ind);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_iscolumnorder_m,
                  SIDL_ENFPOLICY__ARRAY_ISCOLUMNORDER_M,
                  sidl_EnfPolicy__array_isColumnOrder_m)
  (int64_t *array,
   SIDL_F90_Bool *result)
{
  *result = sidl_interface__array_isColumnOrder((struct sidl_interface__array 
    *)(ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_isroworder_m,
                  SIDL_ENFPOLICY__ARRAY_ISROWORDER_M,
                  sidl_EnfPolicy__array_isRowOrder_m)
  (int64_t *array,
   SIDL_F90_Bool *result)
{
  *result = sidl_interface__array_isRowOrder((struct sidl_interface__array *)(
    ptrdiff_t)*array);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_copy_m,
                  SIDL_ENFPOLICY__ARRAY_COPY_M,
                  sidl_EnfPolicy__array_copy_m)
  (int64_t *src,
   int64_t *dest)
{
  sidl_interface__array_copy((const struct sidl_interface__array *)(
    ptrdiff_t)*src,
                             (struct sidl_interface__array *)(ptrdiff_t)*dest);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_smartcopy_m,
                  SIDL_ENFPOLICY__ARRAY_SMARTCOPY_M,
                  sidl_EnfPolicy__array_smartCopy_m)
  (int64_t *src)
{
  sidl_interface__array_smartCopy((struct sidl_interface__array *)(
    ptrdiff_t)*src);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_slice_m,
                  SIDL_ENFPOLICY__ARRAY_SLICE_M,
                  sidl_EnfPolicy__array_slice_m)
  (int64_t *src,
   int32_t *dimen,
   int32_t numElem[],
   int32_t srcStart[],
   int32_t srcStride[],
   int32_t newStart[],
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_slice((struct sidl_interface__array *)(ptrdiff_t)*src,
      *dimen, numElem, srcStart, srcStride, newStart);
}

void
SIDLFortran90Symbol(sidl_enfpolicy__array_ensure_m,
                  SIDL_ENFPOLICY__ARRAY_ENSURE_M,
                  sidl_EnfPolicy__array_ensure_m)
  (int64_t *src,
   int32_t *dimen,
   int     *ordering,
   int64_t *result)
{
  *result = (ptrdiff_t)
    sidl_interface__array_ensure((struct sidl_interface__array *)(
      ptrdiff_t)*src,
    *dimen, *ordering);
}

#ifdef WITH_RMI

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#ifndef included_sidl_BaseClass_h
#include "sidl_BaseClass.h"
#endif
#ifndef included_sidl_ClassInfo_h
#include "sidl_ClassInfo.h"
#endif
#ifndef included_sidl_rmi_ProtocolFactory_h
#include "sidl_rmi_ProtocolFactory.h"
#endif
#ifndef included_sidl_rmi_InstanceRegistry_h
#include "sidl_rmi_InstanceRegistry.h"
#endif
#ifndef included_sidl_rmi_InstanceHandle_h
#include "sidl_rmi_InstanceHandle.h"
#endif
#ifndef included_sidl_rmi_Invocation_h
#include "sidl_rmi_Invocation.h"
#endif
#ifndef included_sidl_rmi_Response_h
#include "sidl_rmi_Response.h"
#endif
#ifndef included_sidl_rmi_ServerRegistry_h
#include "sidl_rmi_ServerRegistry.h"
#endif
#ifndef included_sidl_rmi_ConnectRegistry_h
#include "sidl_rmi_ConnectRegistry.h"
#endif
#ifndef included_sidl_io_Serializable_h
#include "sidl_io_Serializable.h"
#endif
#ifndef included_sidl_MemAllocException_h
#include "sidl_MemAllocException.h"
#endif
#ifndef included_sidl_NotImplementedException_h
#include "sidl_NotImplementedException.h"
#endif
#include "sidl_Exception.h"

#ifndef NULL
#define NULL 0
#endif

#include "sidl_thread.h"
#ifdef HAVE_PTHREAD
static struct sidl_recursive_mutex_t sidl_EnfPolicy__mutex= SIDL_RECURSIVE_MUTEX_INITIALIZER;
#define LOCK_STATIC_GLOBALS sidl_recursive_mutex_lock( &sidl_EnfPolicy__mutex )
#define UNLOCK_STATIC_GLOBALS sidl_recursive_mutex_unlock( &sidl_EnfPolicy__mutex )
/* #define HAVE_LOCKED_STATIC_GLOBALS (sidl_recursive_mutex_trylock( &sidl_EnfPolicy__mutex )==EDEADLOCK) */
#else
#define LOCK_STATIC_GLOBALS
#define UNLOCK_STATIC_GLOBALS
/* #define HAVE_LOCKED_STATIC_GLOBALS (1) */
#endif

/* Static variables to hold version of IOR */
static const int32_t s_IOR_MAJOR_VERSION = 2;
static const int32_t s_IOR_MINOR_VERSION = 0;

/* Static variables for managing EPV initialization. */
static int s_remote_initialized = 0;

static struct sidl_EnfPolicy__epv s_rem_epv__sidl_enfpolicy;

static struct sidl_BaseClass__epv  s_rem_epv__sidl_baseclass;

static struct sidl_BaseInterface__epv  s_rem_epv__sidl_baseinterface;


/* REMOTE CAST: dynamic type casting for remote objects. */
static void* remote_sidl_EnfPolicy__cast(
  struct sidl_EnfPolicy__object* self,
  const char* name, sidl_BaseInterface* _ex)
{
  int cmp;
  void* cast = NULL;
  *_ex = NULL; /* default to no exception */
  cmp = strcmp(name, "sidl.BaseInterface");
  if (!cmp) {
    (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
    cast = &((*self).d_sidl_baseclass.d_sidl_baseinterface);
    return cast;
  }
  else if (cmp < 0) {
    cmp = strcmp(name, "sidl.BaseClass");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = ((struct sidl_BaseClass__object*)self);
      return cast;
    }
  }
  else if (cmp > 0) {
    cmp = strcmp(name, "sidl.EnfPolicy");
    if (!cmp) {
      (*self->d_epv->f_addRef)(self, _ex); SIDL_CHECK(*_ex);
      cast = ((struct sidl_EnfPolicy__object*)self);
      return cast;
    }
  }
  if ((*self->d_epv->f_isType)(self,name, _ex)) {
    void* (*func)(struct sidl_rmi_InstanceHandle__object*, struct 
      sidl_BaseInterface__object**) = 
      (void* (*)(struct sidl_rmi_InstanceHandle__object*, struct 
        sidl_BaseInterface__object**)) 
      sidl_rmi_ConnectRegistry_getConnect(name, _ex);SIDL_CHECK(*_ex);
    cast =  (*func)(((struct sidl_EnfPolicy__remote*)self->d_data)->d_ih, _ex);
  }

  return cast;
  EXIT:
  return NULL;
}

/* REMOTE DELETE: call the remote destructor for the object. */
static void remote_sidl_EnfPolicy__delete(
  struct sidl_EnfPolicy__object* self,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
  free((void*) self);
}

/* REMOTE GETURL: call the getURL function for the object. */
static char* remote_sidl_EnfPolicy__getURL(
  struct sidl_EnfPolicy__object* self, struct sidl_BaseInterface__object* *_ex)
{
  struct sidl_rmi_InstanceHandle__object *conn = ((struct 
    sidl_EnfPolicy__remote*)self->d_data)->d_ih;
  *_ex = NULL;
  if(conn != NULL) {
    return sidl_rmi_InstanceHandle_getObjectURL(conn, _ex);
  }
  return NULL;
}

/* REMOTE ADDREF: For internal babel use only! Remote addRef. */
static void remote_sidl_EnfPolicy__raddRef(
  struct sidl_EnfPolicy__object* self,struct sidl_BaseInterface__object* *_ex)
{
  struct sidl_BaseException__object* netex = NULL;
  /* initialize a new invocation */
  struct sidl_BaseInterface__object* _throwaway = NULL;
  struct sidl_rmi_InstanceHandle__object *_conn = ((struct 
    sidl_EnfPolicy__remote*)self->d_data)->d_ih;
  sidl_rmi_Response _rsvp = NULL;
  sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
    "addRef", _ex ); SIDL_CHECK(*_ex);
  /* send actual RMI request */
  _rsvp = sidl_rmi_Invocation_invokeMethod(_inv,_ex);SIDL_CHECK(*_ex);
  /* Check for exceptions */
  netex = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);
  if(netex != NULL) {
    *_ex = (struct sidl_BaseInterface__object*)netex;
    return;
  }

  /* cleanup and return */
  EXIT:
  if(_inv) { sidl_rmi_Invocation_deleteRef(_inv,&_throwaway); }
  if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp,&_throwaway); }
  return;
}

/* REMOTE ISREMOTE: returns true if this object is Remote (it is). */
static sidl_bool
remote_sidl_EnfPolicy__isRemote(
    struct sidl_EnfPolicy__object* self, 
    struct sidl_BaseInterface__object* *_ex) {
  *_ex = NULL;
  return TRUE;
}

/* REMOTE METHOD STUB:_set_hooks */
static void
remote_sidl_EnfPolicy__set_hooks(
  /* in */ struct sidl_EnfPolicy__object*self ,
  /* in */ sidl_bool enable,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl_EnfPolicy__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_hooks", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl.EnfPolicy._set_hooks.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_set_contracts */
static void
remote_sidl_EnfPolicy__set_contracts(
  /* in */ struct sidl_EnfPolicy__object*self ,
  /* in */ sidl_bool enable,
  /* in */ const char* enfFilename,
  /* in */ sidl_bool resetCounters,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl_EnfPolicy__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_set_contracts", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packBool( _inv, "enable", enable, _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packString( _inv, "enfFilename", enfFilename, 
      _ex);SIDL_CHECK(*_ex);
    sidl_rmi_Invocation_packBool( _inv, "resetCounters", resetCounters, 
      _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl.EnfPolicy._set_contracts.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* Contract enforcement has not been implemented for remote use. */
/* REMOTE METHOD STUB:_dump_stats */
static void
remote_sidl_EnfPolicy__dump_stats(
  /* in */ struct sidl_EnfPolicy__object*self ,
  /* in */ const char* filename,
  /* in */ const char* prefix,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl_EnfPolicy__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "_dump_stats", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "filename", filename, _ex);SIDL_CHECK(
      *_ex);
    sidl_rmi_Invocation_packString( _inv, "prefix", prefix, _ex);SIDL_CHECK(
      *_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl.EnfPolicy._dump_stats.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return;
  }
}

/* REMOTE EXEC: call the exec function for the object. */
static void remote_sidl_EnfPolicy__exec(
  struct sidl_EnfPolicy__object* self,const char* methodName,
  sidl_rmi_Call inArgs,
  sidl_rmi_Return outArgs,
  struct sidl_BaseInterface__object* *_ex)
{
  *_ex = NULL;
}

/* REMOTE METHOD STUB:addRef */
static void
remote_sidl_EnfPolicy_addRef(
  /* in */ struct sidl_EnfPolicy__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct sidl_EnfPolicy__remote* r_obj = (struct 
      sidl_EnfPolicy__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount++;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: addRef %p new count %d (type %s)\n",
      r_obj, r_obj->d_refcount, 
      "sidl.EnfPolicy Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:deleteRef */
static void
remote_sidl_EnfPolicy_deleteRef(
  /* in */ struct sidl_EnfPolicy__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    struct sidl_EnfPolicy__remote* r_obj = (struct 
      sidl_EnfPolicy__remote*)self->d_data;
    LOCK_STATIC_GLOBALS;
    r_obj->d_refcount--;
#ifdef SIDL_DEBUG_REFCOUNT
    fprintf(stderr, "babel: deleteRef %p new count %d (type %s)\n",r_obj, r_obj->d_refcount, "sidl.EnfPolicy Remote Stub");
#endif /* SIDL_DEBUG_REFCOUNT */ 
    if(r_obj->d_refcount == 0) {
      sidl_rmi_InstanceHandle_deleteRef(r_obj->d_ih, _ex);
      free(r_obj);
      free(self);
    }
    UNLOCK_STATIC_GLOBALS;
  }
}

/* REMOTE METHOD STUB:isSame */
static sidl_bool
remote_sidl_EnfPolicy_isSame(
  /* in */ struct sidl_EnfPolicy__object*self ,
  /* in */ struct sidl_BaseInterface__object* iobj,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl_EnfPolicy__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isSame", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    if(iobj){
      char* _url = sidl_BaseInterface__getURL((sidl_BaseInterface)iobj, 
        _ex);SIDL_CHECK(*_ex);
      sidl_rmi_Invocation_packString( _inv, "iobj", _url, _ex);SIDL_CHECK(*_ex);
      free((void*)_url);
    } else {
      sidl_rmi_Invocation_packString( _inv, "iobj", NULL, _ex);SIDL_CHECK(*_ex);
    }

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl.EnfPolicy.isSame.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:isType */
static sidl_bool
remote_sidl_EnfPolicy_isType(
  /* in */ struct sidl_EnfPolicy__object*self ,
  /* in */ const char* name,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    sidl_bool _retval = FALSE;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl_EnfPolicy__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "isType", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */
    sidl_rmi_Invocation_packString( _inv, "name", name, _ex);SIDL_CHECK(*_ex);

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl.EnfPolicy.isType.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackBool( _rsvp, "_retval", &_retval, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE METHOD STUB:getClassInfo */
static struct sidl_ClassInfo__object*
remote_sidl_EnfPolicy_getClassInfo(
  /* in */ struct sidl_EnfPolicy__object*self ,
  /* out */ struct sidl_BaseInterface__object **_ex)
{
  LANG_SPECIFIC_INIT();
  *_ex = NULL;
  {
    /* initialize a new invocation */
    struct sidl_BaseInterface__object* _throwaway = NULL;
    sidl_BaseException _be = NULL;
    sidl_rmi_Response _rsvp = NULL;
    char*_retval_str = NULL;
    struct sidl_ClassInfo__object* _retval = 0;
    struct sidl_rmi_InstanceHandle__object * _conn = ((struct 
      sidl_EnfPolicy__remote*)self->d_data)->d_ih;
    sidl_rmi_Invocation _inv = sidl_rmi_InstanceHandle_createInvocation( _conn, 
      "getClassInfo", _ex ); SIDL_CHECK(*_ex);

    /* pack in and inout arguments */

    /* send actual RMI request */
    _rsvp = sidl_rmi_Invocation_invokeMethod(_inv, _ex);SIDL_CHECK(*_ex);

    _be = sidl_rmi_Response_getExceptionThrown(_rsvp, _ex);SIDL_CHECK(*_ex);
    if (_be != NULL) {
      struct sidl_BaseInterface__object* throwaway_exception = NULL;
      sidl_BaseException_addLine(_be, 
      "Exception unserialized from sidl.EnfPolicy.getClassInfo.",
        &throwaway_exception);
      *_ex = (struct sidl_BaseInterface__object*) sidl_BaseInterface__cast(_be,
        &throwaway_exception);
      goto EXIT;
    }

    /* extract return value */
    sidl_rmi_Response_unpackString( _rsvp, "_retval", &_retval_str, 
      _ex);SIDL_CHECK(*_ex);
    _retval = sidl_ClassInfo__connectI(_retval_str, FALSE, _ex);SIDL_CHECK(
      *_ex);

    /* unpack out and inout arguments */

    /* cleanup and return */
    EXIT:
    if(_inv) { sidl_rmi_Invocation_deleteRef(_inv, &_throwaway); }
    if(_rsvp) { sidl_rmi_Response_deleteRef(_rsvp, &_throwaway); }
    return _retval;
  }
}

/* REMOTE EPV: create remote entry point vectors (EPVs). */
static void sidl_EnfPolicy__init_remote_epv(void)
{
  /* assert( HAVE_LOCKED_STATIC_GLOBALS ); */
  struct sidl_EnfPolicy__epv*     epv = &s_rem_epv__sidl_enfpolicy;
  struct sidl_BaseClass__epv*     e0  = &s_rem_epv__sidl_baseclass;
  struct sidl_BaseInterface__epv* e1  = &s_rem_epv__sidl_baseinterface;

  epv->f__cast               = remote_sidl_EnfPolicy__cast;
  epv->f__delete             = remote_sidl_EnfPolicy__delete;
  epv->f__exec               = remote_sidl_EnfPolicy__exec;
  epv->f__getURL             = remote_sidl_EnfPolicy__getURL;
  epv->f__raddRef            = remote_sidl_EnfPolicy__raddRef;
  epv->f__isRemote           = remote_sidl_EnfPolicy__isRemote;
  epv->f__set_hooks          = remote_sidl_EnfPolicy__set_hooks;
  epv->f__set_contracts      = remote_sidl_EnfPolicy__set_contracts;
  epv->f__dump_stats         = remote_sidl_EnfPolicy__dump_stats;
  epv->f__ctor               = NULL;
  epv->f__ctor2              = NULL;
  epv->f__dtor               = NULL;
  epv->f_addRef              = remote_sidl_EnfPolicy_addRef;
  epv->f_deleteRef           = remote_sidl_EnfPolicy_deleteRef;
  epv->f_isSame              = remote_sidl_EnfPolicy_isSame;
  epv->f_isType              = remote_sidl_EnfPolicy_isType;
  epv->f_getClassInfo        = remote_sidl_EnfPolicy_getClassInfo;

  e0->f__cast          = (void* (*)(struct sidl_BaseClass__object*, const char*,
    struct sidl_BaseInterface__object**)) epv->f__cast;
  e0->f__delete        = (void (*)(struct sidl_BaseClass__object*, struct 
    sidl_BaseInterface__object**)) epv->f__delete;
  e0->f__getURL        = (char* (*)(struct sidl_BaseClass__object*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e0->f__raddRef       = (void (*)(struct sidl_BaseClass__object*, struct 
    sidl_BaseInterface__object**)) epv->f__raddRef;
  e0->f__isRemote      = (sidl_bool (*)(struct sidl_BaseClass__object*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e0->f__set_hooks     = (void (*)(struct sidl_BaseClass__object*, sidl_bool, 
    struct sidl_BaseInterface__object**)) epv->f__set_hooks;
  e0->f__set_contracts = (void (*)(struct sidl_BaseClass__object*, sidl_bool, 
    const char*, sidl_bool, struct sidl_BaseInterface__object**)) 
    epv->f__set_contracts;
  e0->f__dump_stats    = (void (*)(struct sidl_BaseClass__object*, const char*, 
    const char*, struct sidl_BaseInterface__object**)) epv->f__dump_stats;
  e0->f__exec          = (void (*)(struct sidl_BaseClass__object*,const char*,
    struct sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e0->f_addRef         = (void (*)(struct sidl_BaseClass__object*,struct 
    sidl_BaseInterface__object **)) epv->f_addRef;
  e0->f_deleteRef      = (void (*)(struct sidl_BaseClass__object*,struct 
    sidl_BaseInterface__object **)) epv->f_deleteRef;
  e0->f_isSame         = (sidl_bool (*)(struct sidl_BaseClass__object*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e0->f_isType         = (sidl_bool (*)(struct sidl_BaseClass__object*,const 
    char*,struct sidl_BaseInterface__object **)) epv->f_isType;
  e0->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(struct 
    sidl_BaseClass__object*,struct sidl_BaseInterface__object **)) 
    epv->f_getClassInfo;

  e1->f__cast          = (void* (*)(void*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__cast;
  e1->f__delete        = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__delete;
  e1->f__getURL        = (char* (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__getURL;
  e1->f__raddRef       = (void (*)(void*, struct sidl_BaseInterface__object**)) 
    epv->f__raddRef;
  e1->f__isRemote      = (sidl_bool (*)(void*, struct 
    sidl_BaseInterface__object**)) epv->f__isRemote;
  e1->f__set_hooks     = (void (*)(void*, sidl_bool, struct 
    sidl_BaseInterface__object**)) epv->f__set_hooks;
  e1->f__set_contracts = (void (*)(void*, sidl_bool, const char*, sidl_bool, 
    struct sidl_BaseInterface__object**)) epv->f__set_contracts;
  e1->f__dump_stats    = (void (*)(void*, const char*, const char*, struct 
    sidl_BaseInterface__object**)) epv->f__dump_stats;
  e1->f__exec          = (void (*)(void*,const char*,struct 
    sidl_rmi_Call__object*,struct sidl_rmi_Return__object*,struct 
    sidl_BaseInterface__object **)) epv->f__exec;
  e1->f_addRef         = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_addRef;
  e1->f_deleteRef      = (void (*)(void*,struct sidl_BaseInterface__object **)) 
    epv->f_deleteRef;
  e1->f_isSame         = (sidl_bool (*)(void*,struct 
    sidl_BaseInterface__object*,struct sidl_BaseInterface__object **)) 
    epv->f_isSame;
  e1->f_isType         = (sidl_bool (*)(void*,const char*,struct 
    sidl_BaseInterface__object **)) epv->f_isType;
  e1->f_getClassInfo   = (struct sidl_ClassInfo__object* (*)(void*,struct 
    sidl_BaseInterface__object **)) epv->f_getClassInfo;

  s_remote_initialized = 1;
}

/* Create an instance that connects to an existing remote object. */
static struct sidl_EnfPolicy__object*
sidl_EnfPolicy__remoteConnect(const char *url, sidl_bool ar, struct 
  sidl_BaseInterface__object* *_ex)
{
  struct sidl_EnfPolicy__object* self = NULL;

  struct sidl_EnfPolicy__object* s0;
  struct sidl_BaseClass__object* s1;

  struct sidl_EnfPolicy__remote* r_obj = NULL;
  sidl_rmi_InstanceHandle instance = NULL;
  char* objectID = NULL;
  objectID = NULL;
  *_ex = NULL;
  if(url == NULL) {return NULL;}
  objectID = sidl_rmi_ServerRegistry_isLocalObject(url, _ex);
  if(objectID) {
    struct sidl_EnfPolicy__object* retobj = NULL;
    struct sidl_BaseInterface__object *throwaway_exception;
    sidl_BaseInterface bi = (
      sidl_BaseInterface)sidl_rmi_InstanceRegistry_getInstanceByString(objectID,
      _ex); SIDL_CHECK(*_ex);
    (*bi->d_epv->f_deleteRef)(bi->d_object, &throwaway_exception);
    retobj = (struct sidl_EnfPolicy__object*) (*bi->d_epv->f__cast)(
      bi->d_object, "sidl.EnfPolicy", _ex);
    if(!ar) { 
      (*bi->d_epv->f_deleteRef)(bi->d_object, &throwaway_exception);
    }
    return retobj;
  }
  instance = sidl_rmi_ProtocolFactory_connectInstance(url, "sidl.EnfPolicy", ar,
    _ex ); SIDL_CHECK(*_ex);
  if ( instance == NULL) { return NULL; }
  self =
    (struct sidl_EnfPolicy__object*) malloc(
      sizeof(struct sidl_EnfPolicy__object));

  r_obj =
    (struct sidl_EnfPolicy__remote*) malloc(
      sizeof(struct sidl_EnfPolicy__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "sidl.EnfPolicy.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                          self;
  s1 =                          &s0->d_sidl_baseclass;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    sidl_EnfPolicy__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s1->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s1->d_sidl_baseinterface.d_object = (void*) self;

  s1->d_data = (void*) r_obj;
  s1->d_epv  = &s_rem_epv__sidl_baseclass;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__sidl_enfpolicy;

  self->d_data = (void*) r_obj;

  return self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/* Create an instance that uses an already existing  */
/* InstanceHandle to connect to an existing remote object. */
static struct sidl_EnfPolicy__object*
sidl_EnfPolicy__IHConnect(sidl_rmi_InstanceHandle instance, struct 
  sidl_BaseInterface__object* *_ex)
{
  struct sidl_EnfPolicy__object* self = NULL;

  struct sidl_EnfPolicy__object* s0;
  struct sidl_BaseClass__object* s1;

  struct sidl_EnfPolicy__remote* r_obj = NULL;
  self =
    (struct sidl_EnfPolicy__object*) malloc(
      sizeof(struct sidl_EnfPolicy__object));

  r_obj =
    (struct sidl_EnfPolicy__remote*) malloc(
      sizeof(struct sidl_EnfPolicy__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "sidl.EnfPolicy.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                          self;
  s1 =                          &s0->d_sidl_baseclass;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    sidl_EnfPolicy__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s1->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s1->d_sidl_baseinterface.d_object = (void*) self;

  s1->d_data = (void*) r_obj;
  s1->d_epv  = &s_rem_epv__sidl_baseclass;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__sidl_enfpolicy;

  self->d_data = (void*) r_obj;

  sidl_rmi_InstanceHandle_addRef(instance,_ex);SIDL_CHECK(*_ex);
  return self;
  EXIT:
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/* REMOTE: generate remote instance given URL string. */
static struct sidl_EnfPolicy__object*
sidl_EnfPolicy__remoteCreate(const char *url, struct sidl_BaseInterface__object 
  **_ex)
{
  struct sidl_BaseInterface__object* _throwaway_exception = NULL;
  struct sidl_EnfPolicy__object* self = NULL;

  struct sidl_EnfPolicy__object* s0;
  struct sidl_BaseClass__object* s1;

  struct sidl_EnfPolicy__remote* r_obj = NULL;
  sidl_rmi_InstanceHandle instance = sidl_rmi_ProtocolFactory_createInstance(
    url, "sidl.EnfPolicy", _ex ); SIDL_CHECK(*_ex);
  if ( instance == NULL) { return NULL; }
  self =
    (struct sidl_EnfPolicy__object*) malloc(
      sizeof(struct sidl_EnfPolicy__object));

  r_obj =
    (struct sidl_EnfPolicy__remote*) malloc(
      sizeof(struct sidl_EnfPolicy__remote));

  if(!self || !r_obj) {
    sidl_MemAllocException ex = sidl_MemAllocException_getSingletonException(
      _ex);
    SIDL_CHECK(*_ex);
    sidl_MemAllocException_setNote(ex, "Out of memory.", _ex); SIDL_CHECK(*_ex);
    sidl_MemAllocException_add(ex, __FILE__, __LINE__, 
      "sidl.EnfPolicy.EPVgeneration", _ex);
    SIDL_CHECK(*_ex);
    *_ex = (struct sidl_BaseInterface__object*)ex;
    goto EXIT;
  }

  r_obj->d_refcount = 1;
  r_obj->d_ih = instance;
  s0 =                          self;
  s1 =                          &s0->d_sidl_baseclass;

  LOCK_STATIC_GLOBALS;
  if (!s_remote_initialized) {
    sidl_EnfPolicy__init_remote_epv();
  }
  UNLOCK_STATIC_GLOBALS;

  s1->d_sidl_baseinterface.d_epv    = &s_rem_epv__sidl_baseinterface;
  s1->d_sidl_baseinterface.d_object = (void*) self;

  s1->d_data = (void*) r_obj;
  s1->d_epv  = &s_rem_epv__sidl_baseclass;

  s0->d_data = (void*) r_obj;
  s0->d_epv  = &s_rem_epv__sidl_enfpolicy;

  self->d_data = (void*) r_obj;

  return self;
  EXIT:
  if(instance) { sidl_rmi_InstanceHandle_deleteRef(instance, 
    &_throwaway_exception); }
  if(self) { free(self); }
  if(r_obj) { free(r_obj); }
  return NULL;
}
/*
 * RMI connector function for the class.
 */

struct sidl_EnfPolicy__object*
sidl_EnfPolicy__connectI(const char* url, sidl_bool ar, struct 
  sidl_BaseInterface__object **_ex)
{
  return sidl_EnfPolicy__remoteConnect(url, ar, _ex);
}


#endif /*WITH_RMI*/
